-- Статус
-- Система не проверена на предмет математических ошибок (и ошибок вообще, т. е. проверять надо не только математические части, но там вероятность ошибок мала)
-- Нужно проверить, что вся функциональность используется
-- Бескомпромиссное быстродействие не было целью
-- Многие вещи могут быть сделаны непрофессионально, например, недостаточно быстрые тактики
-- В остальном идеально
-- Используются только следующие TODO: END - в конце, TODO - побыстрее, где-то сразу после реализации базового большого набора фич, когда станет ясно, что эта версия долгоживущая

-- Спецификация, всё это полностью принято, END: реализовать и добавить в доки, спецификация также есть в комментах, отмечена SPEC
-- Нужно работать в ZFC (и PA), но используя метатеоремы (например, о полной дедукции в PA). Поэтому нужно разделение металогики и объектной логики. Металогика может содержать Pi по функциям, а объектная логика может не содержать, поэтому могут быть нужны разные Pi. Чтобы сложный Pi не попал внутрь простого, prop и metaprop должны быть разными типами. Метаимпликация будет существовать по определению PTS, но нужна ещё объектная импликация. Metapropsort для нормального равенства без поддержки metaprop. Даже если объектная логика - это HOL, то нужны два Pi. Т. к. мета-Pi не может содержаться внутри объектной импликации
-- Isabelle-style объявления полиморфных переменных, HM-type inference, просто потому что всё это удобно. но для док-в действует сверх-HM-type inference, т. к. у них переменные в неопределённом порядке
-- Прямые De Bruijn indices, т. к. рассмотрим задачу подстановки x вместо y в (%x. y) (например, применение a = b ==> (%x. a) = (%x. b) к x = x). Прямые, т. к. это позволяет рассматривать лямбда-терм без оглядки на контекст. Для "свободных" переменных простая нумерация, т. к. так проще, но тоже числовая, т. к. упомянутые выше примеры ещё сконструировать надо (TODO: добавить тест на этот пример)
-- Должно быть единое пространство имён для констант, лемм и т. д., просто потому что мне так захотелось
-- Вместо того, чтобы экспортить из блока все шаги, нужно просто разрешить в конце блока написать, скажем, "have ... and ...". Так будет красивее, и будет лучше сходиться с идеей "удаление из контекста = один abstraction"
-- Про унификацию. Назовём переменные буквами, а переменные унификации - цифрами. Буквы, разумеется, могут зависеть от цифр, буквы - от букв (Pi a : x < 0. ...), цифры - от цифр, и цифры - от букв (Pi a : (Pi x : 'a. p x ==> q x). a b)

-- Code standard, он уже соблюдается
-- Нужно писать if ... then throwError ... else ..., а не наоборот, даже если тогда придётся писать в if отрицательные утверждения
-- В конструкциях if ... then throwError ... else ... и case ... of { ... -> throwError; ... -> ...; } в качестве успешной альтернативы должен по возможности стоять return (), даже если это приводит к удлинению кода. В частности, "throwError ... else do" быть не должно
-- Исключение из этих правил: код вида if ... then ... else if ... then ... else throwError ...

module IAmAFreeVariable(Sort(..), Scope(), PTerm(PSort, PFree, PApplication, PLambda, PPi), abstract, instantiate) where

-- deriving (Eq) для PTerm
-- deriving (Show) для сообщений об ошибках
data Sort = Metaprop | MetapropSort | ProvableSort | Type | PolymorphicTermSort | TypeSort deriving (Eq, Show)

-- END: Добавить вывод, чтобы все эти String пригодились (то же с UPTerm)
-- Приём в этом файле взят из Conor McBride, James McKinna, "Functional Pearl: I am not a Number - I am a Free Variable", Haskell'04, September 22, 2004, Snowbird, Utah, USA
-- Псевдотерм, он же PTS term
-- deriving (Eq) для abstractInternal
newtype Scope = Scope PTerm deriving (Eq)
data PTerm = PSort Sort | PFree Int | PBinded Int | PApplication PTerm PTerm Sort PTerm PTerm Sort | PLambda String PTerm Sort Scope Scope Sort | PPi String PTerm Sort Scope Sort deriving (Eq)

abstract :: Int -> PTerm -> Scope
abstract name expr = let {
  nameTo outer (PSort a                                ) = PSort a;
  nameTo outer (PFree a                                ) = if a == name then PBinded outer else PFree a;
  nameTo outer (PBinded a                              ) = PBinded a;
  nameTo outer (PApplication a at att b bt btt         ) = PApplication (nameTo outer a) (nameTo outer at) att (nameTo outer b) (nameTo outer bt) btt;
  nameTo outer (PLambda x a at (Scope b) (Scope bt) btt) = PLambda x (nameTo outer a) at (Scope $ nameTo (outer + 1) b) (Scope $ nameTo (outer + 1) bt) btt;
  nameTo outer (PPi     x a at (Scope b) bt            ) = PPi     x (nameTo outer a) at (Scope $ nameTo (outer + 1) b) bt;
} in Scope (nameTo 0 expr)

instantiate :: PTerm -> Scope -> PTerm
instantiate image (Scope body) = let {
  replace outer (PSort a                                ) = PSort a;
  replace outer (PFree a                                ) = PFree a;
  replace outer (PBinded a                              ) = if a == outer then image else PBinded a;
  replace outer (PApplication a at att b bt btt         ) = PApplication (replace outer a) (replace outer at) att (replace outer b) (replace outer bt) btt;
  replace outer (PLambda x a at (Scope b) (Scope bt) btt) = PLambda x (replace outer a) at (Scope $ replace (outer + 1) b) (Scope $ replace (outer + 1) bt) btt;
  replace outer (PPi     x a at (Scope b) bt            ) = PPi     x (replace outer a) at (Scope $ replace (outer + 1) b) bt;
} in replace 0 body
