-- Syntactic type
data SType = STpIdent String | STpApostrophe String | STpArrow SType SType

data STerm = STmIdent String | STmOfType STerm SType | STmApplication STerm STerm

      exprAddNormal 1000 (\f -> iParens $ f 0) $
      exprAddNormal 3 (\f -> do {
        a <- f 4;
        iReservedOp "::";
        t <- iType;
        return $ STmOfType a t;
      }) $
      exprAddRecursive 999 (\f func -> do {
        arg <- f 1000;
        return $ STmApplication func arg;
      }) exprEmpty
      -- TODO: "a::b", lambda, ==>, !!, прочее

data UnifState = UnifState {
  --|uVs :: [Maybe (String, UPTerm)],
  --|uUVs :: [UPTerm],
  uEqs :: Data.Map.Map Int UPTerm
}
type UnifMonad = StateT UnifState (Either String)

occursCheck :: Int -> UPTerm -> UnifMonad Bool
occursCheck needle (UConst _) = return True
occursCheck needle (UFree _) = return True
occursCheck needle (UVar a) = if a == needle
  then return False
  else do {
    st <- get;
    case Data.Map.lookup a $ uEqs st of {
      Nothing -> return True;
      Just b -> occursCheck needle b;
    };
  }
occursCheck needle (UApplication a b) = do {
  result <- occursCheck needle a;
  if result
    then occursCheck needle b
    else return False;
}
occursCheck needle (ULambda _ a b) = do {
  result <- occursCheck needle a;
  if result
    then occursCheck needle $ uInstantiate (UConst stMetaprop) b
    else return False;
}
occursCheck needle (UPi _ a b) = do {
  result <- occursCheck needle a;
  if result
    then occursCheck needle $ uInstantiate (UConst stMetaprop) b
    else return False;
}

unifyVar :: Int -> UPTerm -> UnifMonad ()
unify :: UPTerm -> UPTerm -> UnifMonad ()

unifyVar an b = do {
  st <- get;
  case Data.Map.lookup an $ uEqs st of {
    Nothing -> case b of {
      UVar bn -> if an == bn
        then return ()
        else put $ st { uEqs = Data.Map.insert an b $ uEqs st };
      _ -> do {
        oc <- occursCheck an b;
        if not oc
          then throwError "ocf" -- TODO: error report
          else return ();
        put $ st { uEqs = Data.Map.insert an b $ uEqs st };
      };
    };
    Just a -> unify a b;
  };
}

unify (UVar an) b = unifyVar an b
unify a (UVar bn) = unifyVar bn a

unify (UConst a) (UConst b) = do {
  eq <- stEq a b;
  if not eq
    then throwError "uf const" -- TODO
    else return ();
}
unify (UFree a) (UFree b) = if a /= b
  then throwError "uf free" -- TODO
  else return ();
unify (UApplication a1 b1) (UApplication a2 b2) = do {
  unify a1 a2;
  unify b1 b2;
}
unify (ULambda x a1 b1) (ULambda _ a2 b2) = do {
  unify a1 a2;
  x <- uAddVar x a1;
  unify (uInstantiate x b1) (uInstantiate x b2);
  -- TODO: что делать в этой функции?
  -- TODO: Lens подучить [эти же TODO далее]
  st <- get;
  put $ st { uVs = Control.Lens.Setter.set (Control.Lens.At.ix x) Nothing $ uVs st };
}
unify (UPi x a1 b1) (UPi _ a2 b2) = do {
  unify a1 a2;
  x <- uAddVar x a1;
  unify (uInstantiate x b1) (uInstantiate x b2);
  st <- get;
  put $ st { uVs = Control.Lens.Setter.set (Control.Lens.At.ix x) Nothing $ uVs st };
}
unify _ _ = throwError "uf other" -- TODO

typeCheckTerm (STmOfType a b) = do {
  (a1, a2) <- typeCheckTerm a;
  b1 <- typeCheckType b;
  unify a2 b1;
  return (a1, b1);
}
typeCheckTerm (STmApplication a b) = do {
  (a1, a2) <- typeCheckTerm a;
  (b1, b2) <- typeCheckTerm b;
  result <- uAddUVar $ UConst stType;
  unify a2 (UPi "_" b2 (uAbstract (-1) $ UVar result)); --TODO: эта строчка
  return (UApplication a1 b1, UVar result);
}

uPTermToStatement ::


запретить строкам простираться на несколько строк
ограничить UnifMonad по возможности. и вообще разобраться со всеми монадами
заменить outer state на reader. сделать так, чтобы arrow'илось с гарантией










--------------------------------------

-- TODO: разбить этот файл, возможно, переупорядочить его
-- TODO: везде поддержка abbr

{-# LANGUAGE TemplateHaskell #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE UndecidableInstances #-}
{-# LANGUAGE OverlappingInstances #-} {- Нужен для Imperative -}

import Imperative

-- SPEC: "~~A" должен парситься (желательно "~" при этом должно парситься как reservedOp), поэтому "~" не должен быть среди reservedOpNames. Поэтому парсим всё как reservedOp, и делаем reservedOpNames пустым
-- TODO: Парсер моей системы не пытается выбрать максимально длинный токен, т. е. не пытается сперва распознать ">>" как единый токен, а потом как два раза по ">"
-- SPEC: Моя реализация парсера выражений сделана, т. к. встроенный в Parsec парсер выражений
  -- не позволяет юзерским функциям быть парсерами типа ParsecT s st m a (они там являются обычными чистыми функциями)
  -- не может нормально парсить ~~A
  -- нет поддержки разных необычных продукций типа {a, b}
-- TODO: возможно, этот (т. е. мой) парсер очень тормознут

data ExprTable s st m a = ExprTable (Data.Map.Map Int ([(Int -> ParsecT s st m a) -> ParsecT s st m a], [(Int -> ParsecT s st m a) -> a -> ParsecT s st m a]))

exprEmpty :: ExprTable s st m a
exprEmpty = ExprTable Data.Map.empty

exprAddNormal :: Int -> ((Int -> ParsecT s st m a) -> ParsecT s st m a) -> ExprTable s st m a -> ExprTable s st m a
exprAddNormal priority prod (ExprTable m) = case Data.Map.lookup priority m of {
  Nothing -> ExprTable $ Data.Map.insert priority ([prod], []) m;
  Just (n, r) -> ExprTable $ Data.Map.insert priority (prod:n, r) m;
}

exprAddRecursive :: Int -> ((Int -> ParsecT s st m a) -> a -> ParsecT s st m a) -> ExprTable s st m a -> ExprTable s st m a
exprAddRecursive priority prod (ExprTable m) = case Data.Map.lookup priority m of {
  Nothing -> ExprTable $ Data.Map.insert priority ([], [prod]) m;
  Just (n, r) -> ExprTable $ Data.Map.insert priority (n, prod:r) m;
}

exprParse :: ExprTable s st m a -> ParsecT s st m a
exprParse (ExprTable m) = let parse priority = case Data.Map.minViewWithKey $ Data.Map.filterWithKey (\k _ -> k >= priority) m of {
  Nothing -> parserZero;
  Just ((k, (normalProductions, recursiveProductions)), _) -> do {
    first <- (foldl (<|>) parserZero $ map (\f -> try $ f parse) normalProductions) <|> parse (k + 1);
    let recursives x = do {
      result <- foldl (<|>) parserZero $ map (\f -> try $ f parse x) recursiveProductions;
      recursives result;
    } <|> return x in recursives first;
  };
} in parse 0

type EMT = ExceptT (Int, Int, String)
type InnerParserMT m = ParsecT String () (EMT m)
type OuterParserMT m = ParsecT String () (EMT m)

innerLangDef :: Text.Parsec.Token.GenLanguageDef String () (EMT m)
innerLangDef = Text.Parsec.Token.LanguageDef {
  Text.Parsec.Token.commentStart    = "",
  Text.Parsec.Token.commentEnd      = "",
  Text.Parsec.Token.commentLine     = "",
  Text.Parsec.Token.nestedComments  = False,
  Text.Parsec.Token.identStart      = letter <|> char '_',
  Text.Parsec.Token.identLetter     = alphaNum <|> oneOf "_'",
  Text.Parsec.Token.opStart         = parserZero,
  Text.Parsec.Token.opLetter        = parserZero,
  Text.Parsec.Token.reservedOpNames = [],
  Text.Parsec.Token.reservedNames   = ["_"], -- TODO: реализовать поддержку "_"
  Text.Parsec.Token.caseSensitive   = True
}

outerLangDef :: Text.Parsec.Token.GenLanguageDef String () (EMT m)
outerLangDef = Text.Parsec.Token.LanguageDef {
  Text.Parsec.Token.commentStart    = "(*",
  Text.Parsec.Token.commentEnd      = "*)",
  Text.Parsec.Token.commentLine     = "",
  Text.Parsec.Token.nestedComments  = False,
  Text.Parsec.Token.identStart      = letter <|> char '_',
  Text.Parsec.Token.identLetter     = alphaNum <|> oneOf "_'",
  Text.Parsec.Token.opStart         = parserZero,
  Text.Parsec.Token.opLetter        = parserZero,
  Text.Parsec.Token.reservedOpNames = [],
  -- TODO: идентификаторы, совпадающие с keywords of outer language?
  Text.Parsec.Token.reservedNames   = ["_"],
  Text.Parsec.Token.caseSensitive   = True
}

innerLexer :: Text.Parsec.Token.GenTokenParser String () (EMT m)
innerLexer = Text.Parsec.Token.makeTokenParser innerLangDef

outerLexer :: Text.Parsec.Token.GenTokenParser String () (EMT m)
outerLexer = Text.Parsec.Token.makeTokenParser outerLangDef

iIdentifier    = Text.Parsec.Token.identifier    innerLexer
iWhiteSpace    = Text.Parsec.Token.whiteSpace    innerLexer
iReservedOp    = Text.Parsec.Token.reservedOp    innerLexer
iLexeme        = Text.Parsec.Token.lexeme        innerLexer
iParens        = Text.Parsec.Token.parens        innerLexer

oIdentifier    = Text.Parsec.Token.identifier    outerLexer
oWhiteSpace    = Text.Parsec.Token.whiteSpace    outerLexer
oReservedOp    = Text.Parsec.Token.reservedOp    outerLexer
oLexeme        = Text.Parsec.Token.lexeme        outerLexer
oReserved      = Text.Parsec.Token.reserved      outerLexer

-- TODO: действительно ли заюзать stringLiteral?
oStringLiteral = Text.Parsec.Token.stringLiteral outerLexer

apostropheInternal = try $ do {
  char '\'';
  a <- letter <|> char '_';
  b <- many $ alphaNum <|> oneOf "_'";
  return $ '\'':a:b;
}

iApostrophe :: InnerParserMT m String
iApostrophe = iLexeme apostropheInternal

oApostrophe :: OuterParserMT m String
oApostrophe = oLexeme apostropheInternal

-- NOOW: add sorts to idents

myE :: (MonadError (Int, Int, String) m) => String -> ParsecT str st m a
myE s = do {
  pos <- getPosition;
  throwError (sourceLine pos, sourceColumn pos, s);
}

-- SPEC: De Brujin indices здесь, т. к. (%x. (%x. x)) (TODO: test). Для свободных переменных тоже нужно использовать некие индексы, т. к. придётся работать с UPTerm'ами в рамках унификации высшего порядка
data UScope = UScope UPTerm
data UPTerm = UConst Statement | UFree Int | UBinded Int | UVar Int | UApplication UPTerm UPTerm | ULambda String UPTerm UScope | UPi String UPTerm UScope

uAbstract :: Int -> UPTerm -> UScope
uAbstract name expr = let {
  nameTo outer (UConst a              ) = UConst a;
  nameTo outer (UFree a               ) = if a == name then UBinded outer else UFree a;
  nameTo outer (UBinded a             ) = UBinded a;
  nameTo outer (UVar a                ) = UVar a;
  nameTo outer (UApplication a b      ) = UApplication (nameTo outer a) (nameTo outer b);
  nameTo outer (ULambda x a (UScope b)) = ULambda x (nameTo outer a) (UScope $ nameTo (outer + 1) b);
  nameTo outer (UPi x a (UScope b)    ) = UPi x (nameTo outer a) (UScope $ nameTo (outer + 1) b);
} in UScope (nameTo 0 expr)

uInstantiate :: UPTerm -> UScope -> UPTerm
uInstantiate image (UScope body) = let {
  replace outer (UConst a              ) = UConst a;
  replace outer (UFree a               ) = UFree a;
  replace outer (UBinded a             ) = if a == outer then image else UBinded a;
  replace outer (UVar a                ) = UVar a;
  replace outer (UApplication a b      ) = UApplication (replace outer a) (replace outer b);
  replace outer (ULambda x a (UScope b)) = ULambda x (replace outer a) (UScope $ replace (outer + 1) b);
  replace outer (UPi x a (UScope b)    ) = UPi x (replace outer a) (UScope $ replace (outer + 1) b);
} in replace 0 body

makeRS "idents" [t|Data.Map.Map String PTerm|]

makeRS "vars" [t|[Maybe (String, UPTerm)]|]

findVar :: (VarsR m) => String -> m (Maybe (Int, UPTerm))
findVar s = do {
  vs <- vars;
  case findIndices (\a -> case a of {
    Nothing -> False;
    Just (s2, _) -> s2 == s;
  }) vs of {
    [] -> return $ Nothing;
    a -> return $ Just (last a, snd (vs !! last a));
  };
}

addVar :: (VarsS m) => String -> UPTerm -> m Int
addVar s t = do {
  vs <- vars;
  setVars (vs ++ [Just (s, t)]);
  return $ length $ vs;
}

iTypeAtom :: (IdentsR m, VarsS m) => InnerParserMT m UPTerm
iTypeAtom = do {
  is <- idents;
  i <- iIdentifier;
  case Data.Map.lookup i is of {
    Nothing -> myE $ i ++ ": undeclared identifier";
    Just a -> do {
      if not (hasSort a Type) && not (hasSort a MetapropSort)
        then myE $ i ++ ": not a type"
        else return ();
      return $ UConst a;
    };
  };
} <|> do {
  i <- iApostrophe;
  found <- findVar;
  case found of {
    Nothing -> do {
      result <- addVar i (UConst stType);
      return $ UFree result;
    };
    Just (result, _) -> return $ UFree result;
  };
} <|> iParens iType

iType :: InnerParserMT m UPTerm
iType = do {
  a <- iTypeAtom;
  do {
    iReservedOp "=>";
    b <- iType;
    return $ UPi "_" a (uAbstract (-1) b);
  } <|> return a;
}

iTypeParser :: InnerParserMT m UPTerm
iTypeParser = do {
  iWhiteSpace;
  result <- iType;
  eof;
  return result;
}

-- NOOW: сделать pTermToUPTerm VarsR
pTermToUPTerm :: (VarsS m) => Data.Map.Map Int Int -> Statement -> m UPTerm
pTermToUPTerm m tm = stCase tm
  (\a -> return $ UConst a)
  (\a b -> case Data.Map.lookup a m of {
    Nothing -> return $ UConst b;
    Just c -> return $ UFree c;
  })
  (\a b -> do {
    a2 <- pTermToUPTerm m a;
    b2 <- pTermToUPTerm m b;
    return $ UApplication a2 b2;
  })
  (\a b c -> do {
    b2 <- pTermToUPTerm m b;
    vs <- vars;
    x <- addVar "_" b2;
    c2 <- pTermToUPTerm (Data.Map.insert a x m) c;
    setVars vs;
    -- TODO: строка вместо "_"?
    return $ ULambda "_" b2 (uAbstract x c2);
  })
  (\a b c -> do {
    b2 <- pTermToUPTerm m b;
    vs <- vars;
    x <- uAddVar "_" b2;
    c2 <- pTermToUPTerm (Data.Map.insert a x m) c;
    setVars vs;
    -- TODO: строка вместо "_"?
    return $ UPi "_" b2 (uAbstract x c2);
  })

constTo2UPTerms :: (VarsS m) => Data.Map.Map Int Int -> UPTerm -> Statement -> m (UPTerm, UPTerm)
constTo2UPTerms m tm tp = if hasSort tp PolymorphicTermSort
  then stCase tp
    (\_ -> throwError "internal error: constTo2UPTerms: case error") -- TODO: эти случаи невозможны, так ведь? И у нас точно Pi определённого вида, так?
    (\_ _ -> throwError "internal error: constTo2UPTerms: case error")
    (\_ _ -> throwError "internal error: constTo2UPTerms: case error")
    (\_ _ _ -> throwError "internal error: constTo2UPTerms: case error")
    (\a _ c -> do {
      x <- addUVar $ UConst stType;
      constTo2UPTerms (Data.Map.insert a x m) (UApplication tm (UVar x)) c;
    })
  else do {
    tp2 <- pTermToUPTerm m tp;
    return (tm, tp2);
  }

makeRS "uVars" [|[UPTerm]|]

addUVar :: (UVarsS m) => UPTerm -> m Int
addUVar t = do {
  uvs <- uVars;
  setUVars (uvs ++ [t]);
  return $ length uvs;
}

@
exprAddNormal 1000 (\f -> do {
  is <- idents;
  i <- iIdentifier;
  case Data.Map.lookup i is of {
    Just a -> do {
      if not (hasSortOfPType a Type) && not (hasSort a ProvableSort) && not (hasSortOfPType a PolymorphicTermSort)
        then throwError $ i ++ ": not a term"
        else return ();
      tm <- pTermToUPTerm a;
      tp <- pTypeOf a;
      constTo2UPTerms Data.Map.empty tm tp;
    };
    Nothing -> do {
      found <- findVar i;
      case found of {
        Just (a, tp) -> return (UFree a, tp);
        Nothing -> do {
          tp <- addUVar stType;
          tm <- addVar i (UVar tp);
          return (UFree tm, UVar tp);
        };
      };
    };
  };
}


-- TODO: нормальные сообщения об ошибках, а не "expected" и пр., "-"
runParser :: ParsecT str () (ExceptT (Int, Int, String) m) a -> String -> ExceptT (Int, Int, String) m a
runParser parser document = do {
  result <- runParserT parser () "-" document;
  case result of {
    Left err -> throwError (sourceLine (errorPos err), sourceColumn (errorPos err), Text.Parsec.Error.showErrorMessages "or" "???" "expected" "found" "nothing" (Text.Parsec.Error.errorMessages err));
    Right result -> return result;
  };
}

oInner :: InnerParserMT m a -> OuterParserMT m a
oInner parser = do {
  pos <- getPosition;
  (line, col, document) <- do {
    s <- oIdentifier;
    return (sourceLine pos, sourceColumn pos, s);
  } <|> do {
    s <- oApostrophe;
    return (sourceLine pos, sourceColumn pos, s);
  } <|> do {
    s <- oStringLiteral;
    return (sourceLine pos, sourceColumn pos + 1, s); -- TODO: +-1 и вообще правильная идея?
  };
  result <- lift $ lift $ runExceptT (runParser parser document);
  case result of {
    Left (_, c, s) -> throwError (line, col + c, s);
    Right result -> return result;
  };
}
