-- После написания программы подумать, действительно ли это small kernel или можно потом снаружи поломать


-- Последние штрихи:
-- На самом деле это совсем не small kernel, мы многое не проверяем, скажем, мы не проверяем, что simpleTypes, переданный в typeIdent, действительно не содержит 'a-типы
-- Чистить постоянно такой_стиль_идентификаторов
-- https://downloads.haskell.org/~ghc/latest/docs/html/users_guide/safe-haskell.html
-- Возможно, добавить больше конструкторов на каждый вид id, например, слот, переменная и т. д.
-- Ядро должно делать нормальный pretty printing (либо бросать исключение наружу, а там делается нормальный pretty printing)
-- собственно, не экспортить слишком много. Запретить Etc менять состояние, кроме etc state
-- Ради того, чтобы можно было удобно работать в системах без дедукции (modal K) и не иметь метаимпликации, всё перекорячено:
-- * Для каждой теоремы хранится полный proof object, и он весь парсится при попытке применить эту теорему внутри assume-блока (если у самой теоремы есть предположения) и там вставляются применения vml2010's A1 и A2
-- * И весь этот proof object парсится вообще при любом применении теоремы просто чтобы заменить буквы в object
-- * Может, заюзать proof object конструктор под названием подстановка без совершения реальной подстановки? Чтобы не манипулировать огромным proof object
-- * Ну и потерян Curry-Howard isomorphism
-- Нужно будет в конце посмотреть proof object для какого-нибудь большого доказательства/теории, вдруг там всё неправильно, скажем, лишнее предположение/переменная добавилось к какой-нибудь теореме и пошло-поехало
-- * Запретить левые переменные в доказательстве?
-- * У меня, выходит, вообще нет small kernel'а, т. к. могут тянуться лишние переменные, предположения и т. д. и наружний код этого просто не заметит?
-- Протестировать, что дедукция не работает, если в док-ве юзается nec. rule
-- Можно подумать, как обойтись без вот этих вот string ids:
-- * hackage bound
-- * http://web.archive.org/web/20120218100646/http://www.cs.st-andrews.ac.uk/~james/RESEARCH/notanum.pdf
-- * http://web.archive.org/web/20081120133730/http://www.augustsson.net/Darcs/Lambda/top.pdf
-- * http://www.slideshare.net/ekmett/bound-making-de-bruijn-succ-less
-- * http://ropas.snu.ac.kr/~bruno/papers/ASGDSL.pdf и ASG вообще
-- * http://homepages.inf.ed.ac.uk/slindley/papers/embedding-f.pdf
-- * http://www.cse.chalmers.se/~emax/documents/axelsson2013using.pdf
-- * http://www.cs.mcgill.ca/~complogic/beluga
-- * http://comonad.com/reader/2008/rotten-bananas/
-- * PHOAS, weak HOAS, HOAS
-- Хорошо бы добиться small kernel, но не таская всё время с собой контекст и переименовывая всё на свете постоянно
-- * Глобальный объект в ядре (т. е. создать его можно только в ядре)
-- Нелогично: в ExprCtx сперва идут самодостаточные, внешние вещи (sts, cs), а потом - остальные, а в Proof они идут вперемешку
-- Переименовать везде expr в term?
-- Не юзать error для проверки правильности теорем и тому подобного, это не соответствует духу Хаскелля, нужно юзать, например, Either
-- Перейти на DeriveAnyClass, когда эта фича будет везде доступна в ghc
-- Сделать, чтобы ~~A нормально парсилось

-- TODO Doc: ещё несколько причин, по которым Хаскелль хорош (в дополнение к основным):
-- Нет состояния, значит, можно легко в expr unifier попробовать разные варианты
-- Хаскелль реально расширяет сознание, заставляет задуматься о вещах, о которых не задумываешься. Думаешь над каждым аргументом в функцию и над тем, как правильно использовать результат, контролируешь абсолютно всё, ничего не ускользает от внимания
-- Почему бы не любить Хаскелль вот за эту строчку: unifyExprs vars (RawExpr ae at) (RawExpr be bt) (tEqs, eEqs) = do { tEqs2 <- unifyTypes at bt tEqs; unifyUntypedExprs vars ae be (tEqs2, eEqs); }? (не гарантирую up-to-dateness примеров кода в этом списке)
-- ahaha! using just "ghci" without any debugger (with :l) is easyier even than visual studio! because haskell has no state, so there is no need for stepping back. and any function performed twice will give same output
-- Молодец, аутотренинг - это здорово. Могу посоветовать еще и такую фразу: "У меня хватает денег на нормальную карту от nvidia, но я слишком ленивый, чтобы купить её." - http://bash.im/quote/7553 (да, #7553! примерно в первых сорока страницах баша)

-- TODO: Окончательные вечные решения: перестраивать proof object при дедукции нельзя - получается слишком долго

-- TODO Doc: Следующая комбинация cabal пакетов работает: deepseq-1.4.1.1, containers-0.5.6.3, ghc-7.8.3. Внимание! При сборке проекта в новом окружении double ensure, что rnf работает, и, таким образом, прувер реально проверяет входной файл

-- TODO: error-подход может приводить к подлым ошибкам: строим Proof, он optimize out и мы пропускаем в нём ошибку даже при использовании rnf

{-# LANGUAGE DeriveGeneric #-}

module Kernel where

import qualified GHC.Generics
import qualified Data.List
import qualified Data.Set
import qualified Data.Map
import qualified Control.Applicative
import qualified Control.Monad
import qualified Control.DeepSeq

newtype Imperative a = Imperative { imp :: a }
data ImperativeUnit = ImperativeUnit

upd :: a -> Imperative a
upd a = Imperative a

del :: Imperative ImperativeUnit
del = Imperative ImperativeUnit

instance Monad Imperative where {
  return a = Imperative a;
  Imperative a >>= b = b a;
  fail a = error a;
}

-- Functor-Applicative-Monad proposal заставляет нас сделать это

instance Functor Imperative where {
  fmap = Control.Monad.liftM;
}

instance Control.Applicative.Applicative Imperative where {
  pure = return;
  (<*>) = Control.Monad.ap;
}

data RawType = RawTypeIdent !String | RawTypeArrow !RawType !RawType deriving (GHC.Generics.Generic)
instance Control.DeepSeq.NFData RawType

prettyRawTypeA :: RawType -> (Int, String)
prettyRawType :: Int -> RawType -> String

prettyRawTypeA (RawTypeIdent ident) = (1000, ident)
prettyRawTypeA (RawTypeArrow arg res) = (0, prettyRawType 1 arg ++ " => " ++ prettyRawType 0 res)

prettyRawType opriority t = let (ipriority, s) = prettyRawTypeA t in (if opriority > ipriority then "(" else "") ++ s ++ (if opriority > ipriority then ")" else "")

data Type = Type !(Data.Set.Set String) !(Data.Set.Set String) !RawType deriving (GHC.Generics.Generic)
instance Control.DeepSeq.NFData Type

replaceTypeInType :: Data.Map.Map String RawType -> RawType -> RawType
replaceTypeInType m (RawTypeIdent ident) =
  case Data.Map.lookup ident m of {
    Nothing -> RawTypeIdent ident;
    Just new -> new;
  }
replaceTypeInType m (RawTypeArrow arg res) = RawTypeArrow (replaceTypeInType m arg) (replaceTypeInType m res)

fullReplaceTypeInType :: Data.Map.Map String RawType -> RawType -> RawType
fullReplaceTypeInType m (RawTypeIdent i) =
  case Data.Map.lookup i m of {
    Nothing -> RawTypeIdent i;
    Just new -> fullReplaceTypeInType m new;
  }
fullReplaceTypeInType m (RawTypeArrow arg res) = RawTypeArrow (fullReplaceTypeInType m arg) (fullReplaceTypeInType m res)

typeIdent :: Data.Set.Set String -> String -> Type
typeIdent sts ident =
  if ident !! 0 == '\''
    then Type Data.Set.empty (Data.Set.singleton ident) (RawTypeIdent ident)
    else if Data.Set.member ident sts
      then Type (Data.Set.singleton ident) Data.Set.empty (RawTypeIdent ident)
      else error ("type \"" ++ ident ++ "\" undeclared")

typeArrow :: Type -> Type -> Type
typeArrow (Type simpleTypesArg varsArg arg) (Type simpleTypesRes varsRes res) = Type (Data.Set.union simpleTypesArg simpleTypesRes) (Data.Set.union varsArg varsRes) (RawTypeArrow arg res)

typeOccursCheck :: Data.Map.Map String RawType -> String -> RawType -> Bool

typeOccursCheck m needle (RawTypeIdent i) = needle /= i && case Data.Map.lookup i m of {
  Nothing -> True;
  Just t -> typeOccursCheck m needle t;
}

typeOccursCheck m needle (RawTypeArrow a r) = typeOccursCheck m needle a && typeOccursCheck m needle r

unifyTypesQuestion :: String  -> RawType -> Data.Map.Map String RawType -> Either String (Data.Map.Map String RawType)
unifyTypes         :: RawType -> RawType -> Data.Map.Map String RawType -> Either String (Data.Map.Map String RawType)

unifyTypesQuestion ti u eqs =
  case Data.Map.lookup ti eqs of {
    Nothing -> case u of {
      RawTypeIdent ui -> if ti == ui
        then Right eqs;
        else Right (Data.Map.insert ti u eqs);
      _ -> if typeOccursCheck eqs ti u
        then Right (Data.Map.insert ti u eqs)
        -- TODO: странное сообщение об ошибке: может не содержать в текстовой записи один и тот же тип (например, c (a b) (b a))
        else Left ("type occurs check failed: \"" ++ ti ++ "\" = \"" ++ prettyRawType 0 u ++ "\"");
    };
    Just t2 -> unifyTypes t2 u eqs;
  }

unifyTypes (RawTypeIdent ti@('?':_)) u eqs = unifyTypesQuestion ti u eqs
unifyTypes t (RawTypeIdent ui@('?':_)) eqs = unifyTypesQuestion ui t eqs
unifyTypes (RawTypeIdent ti) (RawTypeIdent ui) eqs = if ti == ui then Right eqs else Left ("type unification failed: \"" ++ ti ++ "\" != \"" ++ ui ++ "\"")
unifyTypes (RawTypeArrow ta tf) (RawTypeArrow ua uf) eqs = unifyTypes ta ua eqs >>= unifyTypes tf uf
unifyTypes t u _ = Left $ "type unification failed: \"" ++ prettyRawType 0 t ++ "\" != \"" ++ prettyRawType 0 u ++ "\""

right :: String -> Either String r -> r
right s (Left l) = error $ s ++ ": " ++ l
right _ (Right r) = r

newType :: Data.Set.Set String -> (Data.Set.Set String, RawType)
newType tVars =
  case Data.List.find (\x -> not (Data.Set.member x tVars)) (map (\x -> "??'$" ++ show x) [1..]) of {
    Nothing -> error "internal error";
    Just result -> (Data.Set.insert result tVars, RawTypeIdent result);
  }

-- Context's type vars -> type vars of type expression to get -> (context's type vars, map)
getType :: Data.Set.Set String -> Data.Set.Set String -> (Data.Set.Set String, Data.Map.Map String RawType)
getType ctxTVars typeVars = Data.Set.foldl (\(ctx2, m) x -> let (ctx3, nt) = newType ctx2 in (ctx3, Data.Map.insert x nt m)) (ctxTVars, Data.Map.empty) typeVars

data RawUntypedExpr = RawUntypedExprIdent !String | RawUntypedExprApply !RawExpr !RawExpr | RawUntypedExprLambda !String !RawExpr deriving (GHC.Generics.Generic)
instance Control.DeepSeq.NFData RawUntypedExpr

data RawExpr = RawExpr !RawUntypedExpr !RawType deriving (GHC.Generics.Generic)
instance Control.DeepSeq.NFData RawExpr

prettyRawExprA :: RawExpr -> (Int, String)
prettyRawExpr :: Int -> RawExpr -> String

prettyRawExprA (RawExpr (RawUntypedExprIdent ident) t) = (3, ident ++ " :: " ++ prettyRawType 0 t)
prettyRawExprA (RawExpr (RawUntypedExprApply func arg) t) = (999, prettyRawExpr 999 func ++ " " ++ prettyRawExpr 1000 arg)
prettyRawExprA (RawExpr (RawUntypedExprLambda x e) (RawTypeArrow t _)) = (3, "%" ++ x ++ " :: " ++ prettyRawType 0 t ++ ". " ++ prettyRawExpr 3 e)
prettyRawExpr opriority e = let (ipriority, s) = prettyRawExprA e in (if opriority > ipriority then "(" else "") ++ s ++ (if opriority > ipriority then ")" else "")

prettyRawUntypedExprA :: RawUntypedExpr -> (Int, String)
prettyRawUntypedExpr :: Int -> RawUntypedExpr -> String

prettyRawUntypedExprA (RawUntypedExprIdent ident) = (3, ident)
prettyRawUntypedExprA (RawUntypedExprApply f a) = (999, prettyRawExpr 999 f ++ " " ++ prettyRawExpr 1000 a)
prettyRawUntypedExprA (RawUntypedExprLambda x e) = (3, "%" ++ x ++ ". " ++ prettyRawExpr 3 e)
prettyRawUntypedExpr opriority e = let (ipriority, s) = prettyRawUntypedExprA e in (if opriority > ipriority then "(" else "") ++ s ++ (if opriority > ipriority then ")" else "")

-- Отдельный ExprCtx нужен для правил вывода внутри proof objects
data ExprCtx = ExprCtx { ectxSimpleTypes :: !(Data.Set.Set String), ectxConsts :: !(Data.Map.Map String Type), ectxTypeVars :: !(Data.Set.Set String), ectxVars :: !(Data.Map.Map String RawType) } deriving (GHC.Generics.Generic)
instance Control.DeepSeq.NFData ExprCtx

emptyExprCtx :: ExprCtx
emptyExprCtx = ExprCtx Data.Set.empty Data.Map.empty Data.Set.empty Data.Map.empty

data Expr = Expr !ExprCtx !RawExpr deriving (GHC.Generics.Generic)
instance Control.DeepSeq.NFData Expr

replaceTypeInUntypedExpr :: Data.Map.Map String RawType -> RawUntypedExpr -> RawUntypedExpr
replaceTypeInExpr        :: Data.Map.Map String RawType -> RawExpr        -> RawExpr
replaceTypeInUntypedExpr m (RawUntypedExprIdent i) = RawUntypedExprIdent i
replaceTypeInUntypedExpr m (RawUntypedExprApply f a) = RawUntypedExprApply (replaceTypeInExpr m f) (replaceTypeInExpr m a)
replaceTypeInUntypedExpr m (RawUntypedExprLambda x e) = RawUntypedExprLambda x (replaceTypeInExpr m e)
replaceTypeInExpr m (RawExpr e t) = RawExpr (replaceTypeInUntypedExpr m e) (replaceTypeInType m t)

replaceExprInUntypedExpr :: Data.Map.Map String RawUntypedExpr -> RawUntypedExpr -> RawUntypedExpr
replaceExprInExpr        :: Data.Map.Map String RawUntypedExpr -> RawExpr        -> RawExpr

replaceExprInUntypedExpr m (RawUntypedExprIdent i) =
  case Data.Map.lookup i m of {
    Just new -> new;
    Nothing -> RawUntypedExprIdent i;
  }

replaceExprInUntypedExpr m (RawUntypedExprApply f a) = RawUntypedExprApply (replaceExprInExpr m f) (replaceExprInExpr m a)
replaceExprInUntypedExpr m (RawUntypedExprLambda x e) = RawUntypedExprLambda x (replaceExprInExpr (Data.Map.delete x m) e)

replaceExprInExpr m (RawExpr e t) = RawExpr (replaceExprInUntypedExpr m e) t

fullReplaceTypeInUntypedExpr :: Data.Map.Map String RawType -> RawUntypedExpr -> RawUntypedExpr
fullReplaceTypeInExpr        :: Data.Map.Map String RawType -> RawExpr        -> RawExpr
fullReplaceTypeInUntypedExpr m (RawUntypedExprIdent i) = RawUntypedExprIdent i
fullReplaceTypeInUntypedExpr m (RawUntypedExprApply f a) = RawUntypedExprApply (fullReplaceTypeInExpr m f) (fullReplaceTypeInExpr m a)
fullReplaceTypeInUntypedExpr m (RawUntypedExprLambda x e) = RawUntypedExprLambda x (fullReplaceTypeInExpr m e)
fullReplaceTypeInExpr m (RawExpr e t) = RawExpr (fullReplaceTypeInUntypedExpr m e) (fullReplaceTypeInType m t)

fullReplaceExprInUntypedExpr :: Data.Map.Map String RawUntypedExpr -> RawUntypedExpr -> RawUntypedExpr
fullReplaceExprInExpr        :: Data.Map.Map String RawUntypedExpr -> RawExpr        -> RawExpr

fullReplaceExprInUntypedExpr m (RawUntypedExprIdent i) =
  case Data.Map.lookup i m of {
    Just new -> fullReplaceExprInUntypedExpr m new;
    Nothing -> RawUntypedExprIdent i;
  }

fullReplaceExprInUntypedExpr m (RawUntypedExprApply f a) = RawUntypedExprApply (fullReplaceExprInExpr m f) (fullReplaceExprInExpr m a)
fullReplaceExprInUntypedExpr m (RawUntypedExprLambda x e) = RawUntypedExprLambda x (fullReplaceExprInExpr (Data.Map.delete x m) e)

fullReplaceExprInExpr m (RawExpr e t) = RawExpr (fullReplaceExprInUntypedExpr m e) t

exprIdent :: Data.Map.Map String Type -> String -> Expr
exprIdent cs ident =
  case Data.Map.lookup ident cs of {
    Nothing -> let (tVars, t) = newType Data.Set.empty in Expr emptyExprCtx { ectxTypeVars = tVars, ectxVars = Data.Map.singleton ident t } (RawExpr (RawUntypedExprIdent ident) t);
    Just fullType@(Type sts typeVars t) -> let (ctxTVars, m) = getType Data.Set.empty typeVars in Expr emptyExprCtx { ectxTypeVars = ctxTVars, ectxSimpleTypes = sts, ectxConsts = Data.Map.singleton ident fullType } (RawExpr (RawUntypedExprIdent ident) (replaceTypeInType m t));
  }

exprTyped :: Expr -> Type -> Expr
exprTyped (Expr ctx@ExprCtx { ectxSimpleTypes = sts, ectxTypeVars = tvs, ectxVars = vs } (RawExpr e t)) (Type sts2 tvs2 t2) =
  let m = right ("expression \"" ++ prettyRawExpr 0 (RawExpr e t) ++ "\" :: \"" ++ prettyRawType 0 t2 ++ "\"") $ unifyTypes t t2 Data.Map.empty in
    Expr ctx { ectxSimpleTypes = Data.Set.union sts sts2, ectxTypeVars = Data.Set.difference (Data.Set.union tvs tvs2) (Data.Map.keysSet m), ectxVars = Data.Map.map (fullReplaceTypeInType m) vs } (fullReplaceTypeInExpr m (RawExpr e t))

importExprCtx :: ExprCtx -> ExprCtx -> (ExprCtx, Data.Map.Map String RawType, Data.Map.Map String RawType)
importExprCtx (ExprCtx mySts myCs myTvs myVs) (ExprCtx yourSts yourCs yourTvs yourVs) =
  let {
    (myTvs2, m) = getType myTvs (Data.Set.filter (\x -> x !! 0 == '?') yourTvs);

    yourSts2 = yourSts;
    yourCs2 = yourCs;
    ourTvs = Data.Set.union myTvs2 (Data.Set.filter (\x -> x !! 0 /= '?') yourTvs);
    yourVs2 = Data.Map.map (replaceTypeInType m) yourVs;

    m2 = Data.Map.foldl (\m (t1, t2) -> right "importExprCtx" $ unifyTypes t1 t2 m) Data.Map.empty (Data.Map.intersectionWith (\x y -> (x, y)) myVs yourVs2);

    ourSts2 = Data.Set.union mySts yourSts2;
    ourCs2 = Data.Map.union myCs yourCs2; -- TODO: здесь не проверяем корректность union и в других таких же местах
    ourTvs2 = Data.Set.difference ourTvs (Data.Map.keysSet m2);
    ourVs2 = Data.Map.map (fullReplaceTypeInType m2) (Data.Map.union myVs yourVs2);
  } in
    (ExprCtx ourSts2 ourCs2 ourTvs2 ourVs2, m, m2)

importExpr :: ExprCtx -> Expr -> (ExprCtx, Data.Map.Map String RawType, RawExpr)
importExpr myCtx (Expr yourCtx yourE) = let (ourCtx, m1, m2) = importExprCtx myCtx yourCtx in (ourCtx, m2, fullReplaceTypeInExpr m2 (replaceTypeInExpr m1 yourE))

exprApply :: Expr -> Expr -> Expr
exprApply (Expr ctxF f) a =
  let {
    (ExprCtx sts cs tvs vs, m, RawExpr eA2 tA2) = importExpr ctxF a;
    RawExpr eF2 tF2 = fullReplaceTypeInExpr m f;

    (tvs2, nt) = newType tvs;
    m2 = right ("expression \"" ++ prettyRawExpr 0 (RawExpr eF2 tF2) ++ "\" \"" ++ prettyRawExpr 0 (RawExpr eA2 tA2) ++ "\"") $ unifyTypes tF2 (RawTypeArrow tA2 nt) Data.Map.empty;

    tvs3 = Data.Set.difference tvs2 (Data.Map.keysSet m2);
    vs2 = Data.Map.map (fullReplaceTypeInType m2) vs;
  } in
    Expr (ExprCtx sts cs tvs3 vs2) (fullReplaceTypeInExpr m2 (RawExpr (RawUntypedExprApply (RawExpr eF2 tF2) (RawExpr eA2 tA2)) nt))

internalExprLambda :: String -> RawType -> Expr -> Expr
internalExprLambda x t (Expr (ExprCtx sts cs tvs vs) (RawExpr e eT)) =
  let m = case Data.Map.lookup x vs of { Nothing -> Data.Map.empty; Just t2 -> right "lambda expression" $ unifyTypes t t2 Data.Map.empty; } in
    Expr (ExprCtx sts cs (Data.Set.difference tvs (Data.Map.keysSet m)) (Data.Map.map (fullReplaceTypeInType m) (Data.Map.delete x vs))) (fullReplaceTypeInExpr m (RawExpr (RawUntypedExprLambda x (RawExpr e eT)) (RawTypeArrow t eT)))

exprLambda :: String -> Expr -> Expr
exprLambda x (Expr (ExprCtx sts cs tvs vs) e) = let (tvs2, nt) = newType tvs in internalExprLambda x nt (Expr (ExprCtx sts cs tvs2 vs) e)

exprTypedLambda :: String -> Type -> Expr -> Expr
exprTypedLambda x (Type sts1 tvs1 t) (Expr (ExprCtx sts2 cs tvs2 vs) e) = internalExprLambda x t (Expr (ExprCtx (Data.Set.union sts1 sts2) cs (Data.Set.union tvs1 tvs2) vs) e)

untypedExprOccursCheck :: Data.Map.Map String RawUntypedExpr -> String -> RawUntypedExpr -> Bool
exprOccursCheck        :: Data.Map.Map String RawUntypedExpr -> String -> RawExpr        -> Bool

untypedExprOccursCheck m needle (RawUntypedExprIdent i) = needle /= i && case Data.Map.lookup i m of {
  Nothing -> True;
  Just a -> untypedExprOccursCheck m needle a;
}

untypedExprOccursCheck m needle (RawUntypedExprApply f a) = exprOccursCheck m needle f && exprOccursCheck m needle a

untypedExprOccursCheck m needle (RawUntypedExprLambda x e) = needle == x || exprOccursCheck m needle e

exprOccursCheck m needle (RawExpr e _) = untypedExprOccursCheck m needle e

-- unifyUntypedExprs совершенно всегда предполагает, что типы у выражений равны

-- TODO: в идеале, у ?-переменных (как типовых, так и выражений) не должны храниться типы

newVar :: Data.Set.Set String -> (Data.Set.Set String, RawUntypedExpr)
newVar vars =
  case Data.List.find (\x -> not (Data.Set.member x vars)) (map (\x -> "$" ++ show x) [1..]) of {
    Nothing -> error "internal error";
    Just result -> (Data.Set.insert result vars, RawUntypedExprIdent result);
  }

newExpr :: Data.Set.Set String -> (Data.Set.Set String, RawUntypedExpr)
newExpr vars =
  case Data.List.find (\x -> not (Data.Set.member x vars)) (map (\x -> "?$" ++ show x) [1..]) of {
    Nothing -> error "internal error";
    Just result -> (Data.Set.insert result vars, RawUntypedExprIdent result);
  }

unifyUntypedExprsQuestion :: Data.Set.Set String -> String         -> RawUntypedExpr -> (Data.Map.Map String RawType, Data.Map.Map String RawUntypedExpr) -> Either String (Data.Map.Map String RawType, Data.Map.Map String RawUntypedExpr)
unifyUntypedExprs         :: Data.Set.Set String -> RawUntypedExpr -> RawUntypedExpr -> (Data.Map.Map String RawType, Data.Map.Map String RawUntypedExpr) -> Either String (Data.Map.Map String RawType, Data.Map.Map String RawUntypedExpr)
unifyExprs                :: Data.Set.Set String -> RawExpr        -> RawExpr        -> (Data.Map.Map String RawType, Data.Map.Map String RawUntypedExpr) -> Either String (Data.Map.Map String RawType, Data.Map.Map String RawUntypedExpr)

unifyUntypedExprsQuestion vars ai b (tEqs, eEqs) =
  case Data.Map.lookup ai eEqs of {
    Nothing -> case b of {
      RawUntypedExprIdent bi -> if ai == bi
        then Right (tEqs, eEqs)
        else Right (tEqs, Data.Map.insert ai b eEqs);
      _ -> if untypedExprOccursCheck eEqs ai b
        then Right (tEqs, Data.Map.insert ai b eEqs)
        else Left ("expr occurs check failed: \"" ++ ai ++ "\" = \"" ++ prettyRawUntypedExpr 0 b ++ "\"");
    };
    Just a -> unifyUntypedExprs vars a b (tEqs, eEqs);
  }

unifyUntypedExprs vars (RawUntypedExprIdent ai@('?':_)) b eqs = unifyUntypedExprsQuestion vars ai b eqs

unifyUntypedExprs vars a (RawUntypedExprIdent bi@('?':_)) eqs = unifyUntypedExprsQuestion vars bi a eqs

unifyUntypedExprs _    (RawUntypedExprIdent ai) (RawUntypedExprIdent bi) eqs = if ai == bi then Right eqs else Left ("expr unification failed: \"" ++ ai ++ "\" != \"" ++ bi ++ "\"")

unifyUntypedExprs vars (RawUntypedExprApply af aa) (RawUntypedExprApply bf ba) eqs = unifyExprs vars af bf eqs >>= unifyExprs vars aa ba

unifyUntypedExprs vars (RawUntypedExprLambda ax ae) (RawUntypedExprLambda bx be) eqs = let (vars2, ne) = newVar vars in unifyExprs vars2 (replaceExprInExpr (Data.Map.singleton ax ne) ae) (replaceExprInExpr (Data.Map.singleton bx ne) be) eqs

unifyUntypedExprs _ a b _ = Left $ "HIGHER NOT IMPL! expr unification failed: \"" ++ prettyRawUntypedExpr 0 a ++ "\" != \"" ++ prettyRawUntypedExpr 0 b ++ "\""

unifyExprs vars (RawExpr ae at) (RawExpr be bt) (tEqs, eEqs) = do { tEqs2 <- unifyTypes at bt tEqs; unifyUntypedExprs vars ae be (tEqs2, eEqs); }

-- Context's vars -> vars of expression to get -> (context's vars, map)
getExpr :: Data.Set.Set String -> Data.Set.Set String -> (Data.Set.Set String, Data.Map.Map String RawUntypedExpr)
getExpr ctxVars vars = Data.Set.foldl (\(ctx2, m) x -> let (ctx3, ne) = newExpr ctx2 in (ctx3, Data.Map.insert x ne m)) (ctxVars, Data.Map.empty) vars

data Proof = Proof !ExprCtx !(Data.Set.Set String) !(Data.Map.Map String (ExprCtx, [RawExpr], RawExpr)) !(Data.Map.Map String RawExpr) !RawExpr deriving (GHC.Generics.Generic)
instance Control.DeepSeq.NFData Proof

-- TODO: можно просто сделать proofAssume без аргументов и потом его делать каким нужно при помощи proofTyped. И вообще, proofAssume - это predefined rule. И все аналогичные вещи
proofAssume :: Expr -> Proof
proofAssume (Expr ctx e) = Proof ctx Data.Set.empty Data.Map.empty (Data.Map.singleton "$" e) e

proofRule :: String -> [Expr] -> Expr -> Proof
proofRule ident ps (Expr ctx c) = let {
  (ctx2, ps2, c2) = Data.List.foldr (\p (ctx, ps, c) -> let (ctx2, m, p2) = importExpr ctx p in (ctx2, p2:(map (fullReplaceTypeInExpr m) ps), fullReplaceTypeInExpr m c)) (ctx, [], c) ps;
  dollars = map (\x -> "$" ++ show x) [1..]; -- Yeah, infinite amount of money! :)
} in
  Proof ctx2 Data.Set.empty (Data.Map.singleton ident (ctx2, ps2, c2)) (Data.Map.fromList (zip dollars ps2)) c2

proofCut :: Proof -> String -> Proof -> Proof
proofCut (Proof sCtx sQVars sRules sAssms sExpr) i (Proof lCtx lQVars lRules lAssms lExpr) = let {
  (ExprCtx sts cs tvs vs, m1, m2) = importExprCtx lCtx sCtx;

  sAssms2 = Data.Map.map (replaceTypeInExpr m1) sAssms;
  sExpr2  = replaceTypeInProof m1 sExpr;

  sAssms3 = Data.Map.map (fullReplaceTypeInExpr m2) sAssms2;
  lAssms3 = Data.Map.map (fullReplaceTypeInExpr m2) lAssms;
  sExpr3 = fullReplaceTypeInExpr m2 sExpr2;
  lExpr3 = fullReplaceTypeInExpr m2 lExpr;

  (qVars, m3) = getExpr lQVars sQVars;

  sAssms4 = Data.Map.map (replaceExprInExpr m3) sAssms3;
  sExpr4  = replaceExprInExpr m3 sExpr3;

  rules = Data.Map.union sRules lRules;

  -- Достаём assm

  assm = case Data.Map.lookup i lAssms3 of { Nothing -> error $ "cut: no assimption \"" ++ i ++ "\" for small proof of ... ==> \"" ++ prettyRawExpr 0 sExpr4 ++ "\""; Just assm -> assm; };

  -- TODO: tEqs нужно применять к eEqs?
  (m4a, m4b) = right ("cut: assimption \"" ++ i ++ "\": \"" ++ prettyRawExpr 0 assm ++ "\" and small proof of ... ==> \"" ++ prettyRawExpr 0 sExpr4 ++ "\"") $ unifyExprs Data.Set.empty sExpr4 assm (Data.Map.empty, Data.Map.empty);

  -- С этого момента assm "равен" sExpr4, поэтому assm можно считать несуществующим, и sExpr4 тоже

  tvs2     = Data.Set.difference tvs (Data.Map.keysSet m4a);
  vs2      = Data.Map.map (fullReplaceTypeInType m4a) vs;
  sAssms4h = Data.Map.map (fullReplaceTypeInExpr m4a) sAssms4;
  lAssms4h = Data.Map.map (fullReplaceTypeInExpr m4a) (Data.Map.delete i lAssms3);
  lExpr4h  = fullReplaceTypeInExpr m4a lExpr3;

  qVars2  = Data.Set.difference qVars (Data.Map.keysSet m4b);
  sAssms5 = Data.Map.map (fullReplaceExprInExpr m4b) sAssms4h;
  lAssms5 = Data.Map.map (fullReplaceExprInExpr m4b) lAssms4h;
  lExpr5  = fullReplaceExprInExpr m4b lExpr4h;

  newAssm = (\assms val ->
    case Data.List.find (\x -> not (Data.Map.member x assms)) (map (\x -> "$" ++ show x) [1::Int ..]) of {
      Nothing -> error "internal error";
      Just result -> Data.Map.insert result val assms;
    }
  );

  -- Context's assms -> assms of proof to get -> context's assms
  getAssm = (\ctxAssms assms -> Data.Map.foldl newAssm ctxAssms assms);

  assms = getAssm lAssms5 sAssms5;
} in
  Proof (ExprCtx sts cs tvs2 vs2) qVars2 rules assms lExpr5

proofTyped :: Expr -> Proof -> Proof
proofTyped yourE (Proof myCtx qVars rules assms myE0) = let {
  (ExprCtx sts cs tvs vs, m, yourE2) = importExpr myCtx yourE;

  assms2 = Data.Map.map (fullReplaceTypeInExpr m) assms;
  myE = fullReplaceTypeInExpr m myE0;

  (m2, m3) = right ("\"type\" \"" ++ prettyRawExpr 0 yourE2 ++ "\" and proof of ... ==> \"" ++ prettyRawExpr 0 myE ++ "\"") $ unifyExprs Data.Set.empty myE yourE2 (Data.Map.empty, Data.Map.empty);

  tvs2 = Data.Set.difference tvs (Data.Map.keysSet m2);
  vs2 = Data.Map.map (fullReplaceTypeInType m2) vs;
  assms3 = Data.Map.map (fullReplaceTypeInExpr m2) assms2;
  expr3 = fullReplaceTypeInExpr m2 myE;
} in
  Proof (ExprCtx sts cs tvs2 vs2) (Data.Set.difference qVars (Data.Map.keysSet m3)) rules (Data.Map.map (fullReplaceExprInExpr m3) assms3) (fullReplaceExprInExpr m3 expr3)

proofGeneralize :: Proof -> Proof
proofGeneralize (Proof (ExprCtx sts cs tvs vs) qVars rules assms expr) = let {
  (tvs2, m) = getType Data.Set.empty tvs;

  -- vs2 = map (replaceTypeInType m) vs -- Не делаем этого, т. к. дальше интересует только keysSet
  assms2 = Data.Map.map (replaceTypeInExpr m) assms;
  expr2 = replaceTypeInProof m expr;

  (qVars2, m2) = getExpr Data.Set.empty (Data.Set.union (Data.Map.keysSet vs) qVars);

  assms3 = Data.Map.map (replaceExprInExpr m2) assms2;
  expr3 = replaceExprInExpr m2 expr2;
} in
  Proof (ExprCtx sts cs tvs2 Data.Map.empty) qVars2 rules assms3 expr3

-- TODO: возможно, в идеале нужно требовать правила !! B. B ==> A --> B
-- На этом small kernel закончен. Далее идут функции для удобства

assumesShows :: [Expr] -> [Expr]
assumesShows es = let {
  (ExprCtx sts cs tvs vs, es2) = foldr (\e (ctx, es) -> let (ctx2, m, e2) = importExpr ctx e in (ctx2, e2:(map (fullReplaceTypeInExpr m) es))) (emptyExprCtx, []) es;

  qs = Data.Set.filter (\x -> x !! 0 == '?') tvs;
  m = Data.Map.fromSet (\(_:(_:x)) -> RawTypeIdent x) qs;

  tvs2 = Data.Set.difference tvs qs;
  vs2 = Data.Map.map (replaceTypeInType m) vs;
  es3 = map (replaceTypeInExpr m) es2;
} in
  map (Expr (ExprCtx sts cs tvs2 vs2)) es3

-- TODO: Объединять assms было решено здесь, а не в proofCut, а на лишние переменные пока забьём. На появление новых переменных и пр. внутри доказательства. И ещё на много что забьём. Ещё этот proofAssms может ломать small kernel, т. е. приводить к построению левого доказательства
proofAssms :: [Expr] -> Proof -> Proof
proofAssms es (Proof ctx qvars rules assms expr) = let {
  (zero, assms2) = foldl (\(oldAssms, newAssms) (i, e) -> let {
    set = Data.Map.foldlWithKey (\is i assm ->
      case unifyExprs Data.Set.empty assm e (Data.Map.empty, Data.Map.empty) of {
        Left _ -> is;
        Right (m1, m2) -> if Data.Map.null m1 && Data.Map.null m2 then Data.Set.insert i is else error "internal error";
      }) Data.Set.empty oldAssms;

    oldAssms2 = Data.Set.foldl (\a x -> Data.Map.delete x a) oldAssms set;

    newAssms2 = Data.Map.insert i e newAssms;
  } in
    (oldAssms2, newAssms2)) (assms, Data.Map.empty) (zip (map (\x -> "$" ++ show x) [1..]) (map (\(Expr _ x) -> x) es));
} in
  if not (Data.Map.null zero)
    then error "extra assumptions used in theorem"
    else Proof ctx qvars rules assms2 expr

>>>>exprEq :: Expr -> Expr -> Bool
exprEq (Expr ctx a) b = imp $ do {
  (ctx, m, b) <- upd $ importExpr ctx b;
  a <- upd $ fullReplaceTypeInExpr m a;
  m <- del;

  upd $ case unifyExprs Data.Set.empty a b (Data.Map.empty, Data.Map.empty) of {
    Left _ -> False;
    Right _ -> True;
  };
}

-- не выкидывать/выкидывать переменные? (? -> !)
