-- pts. Вообще не ценен, предназначен для выкидывания, но должен работать хорошо, с точки зрения практики без ошибок. Инструмент для исследования. Не может быть правил (a, b, c) и (a, b, d). У каждого сорта должно быть не более одного сорта. У этого файла нет "TODO"

{-# LANGUAGE FlexibleContexts #-}

module Kernel where

import qualified Data.Maybe
import Control.Monad.Error.Class (MonadError, throwError)

-- Псевдотерм, он же PTS-term. "deriving (Eq)" for "merge"
data PTerm = Free Int | Binded Int | Application PTerm PTerm | Lambda String PTerm PTerm | Pi String PTerm PTerm Int deriving (Eq, Show)

data Statement = Statement Int [(Int, Int)] [((Int, Int), Int)] [Maybe (String, PTerm)] PTerm PTerm (Maybe Int) deriving (Show)

runMaybe :: (MonadError String m) => Maybe a -> m a
runMaybe (Just x) = return x
runMaybe Nothing = throwError "internal error: runMaybe"

pTermToSort :: (MonadError String m) => PTerm -> m Int
pTermToSort x = case betaNormal x of {
  Free x -> if x < 0
    then return x
    else throwError "not a sort";
  _ -> throwError $ "internal error: pTermToSort: " ++ show x;
}

createPTS :: (MonadError String m) => [String] -> [(String, String)] -> [(String, String, String)] -> m [(String, Statement)]
createPTS a b c = do {
  dict <- return $ zip a [-1,-2..];
  bb <- mapM (\(a, b) -> do {
    x <- runMaybe $ lookup a dict;
    y <- runMaybe $ lookup b dict;
    return (x, y);
  }) b;
  cc <- mapM (\(x, y, z) -> do {
    xx <- runMaybe $ lookup x dict;
    yy <- runMaybe $ lookup y dict;
    zz <- runMaybe $ lookup z dict;
    return ((xx, yy), zz);
  }) c;
  mapM (\(x, y) -> do {
    xx <- runMaybe $ lookup x dict;
    yy <- runMaybe $ lookup y dict;
    return (x, Statement (length a) bb cc [] (Free xx) (Free yy) (lookup yy bb));
  }) b;
}

merge :: (MonadError String m) => [Maybe (String, PTerm)] -> [Maybe (String, PTerm)] -> m [Maybe (String, PTerm)]

merge [] ys = return ys

merge xs [] = return xs

merge (Nothing:xs) (y:ys) = do {
  result <- merge xs ys;
  return $ y:result;
}

merge (x:xs) (Nothing:ys) = do {
  result <- merge xs ys;
  return $ x:result;
}

merge ((Just x):xs) ((Just y):ys) = if x /= y
  then throwError "internal error: merge"
  else do {
    result <- merge xs ys;
    return $ (Just x):result;
  }

replaceF      :: Int -> PTerm -> PTerm      -> PTerm

replaceF x tm (Free y) = if y == x then tm else Free y
replaceF x tm (Binded y) = Binded y
replaceF x tm (Application a b) = Application (replaceF x tm a) (replaceF x tm b)
replaceF x tm (Lambda y a b   ) = Lambda y (replaceF x tm a) (replaceF x (shift 1 0 tm) b)
replaceF x tm (Pi     y a b s ) = Pi     y (replaceF x tm a) (replaceF x (shift 1 0 tm) b) s

replaceB      :: Int -> PTerm -> PTerm      -> PTerm

replaceB x tm (Free y) = Free y
replaceB x tm (Binded y) = if y == x then tm else Binded y
replaceB x tm (Application a b) = Application (replaceB x tm a) (replaceB x tm b)
replaceB x tm (Lambda y a b   ) = Lambda y (replaceB x tm a) (replaceB (x + 1) (shift 1 0 tm) b)
replaceB x tm (Pi     y a b s ) = Pi     y (replaceB x tm a) (replaceB (x + 1) (shift 1 0 tm) b) s

shift :: Int -> Int -> PTerm      -> PTerm
shift x n (Free y) = Free y
shift x n (Binded y) = if y >= n then Binded (y + x) else Binded y
shift x n (Application a b) = Application (shift x n a) (shift x n b)
shift x n (Lambda y a b   ) = Lambda y (shift x n a) (shift x (n + 1) b)
shift x n (Pi     y a b s ) = Pi     y (shift x n a) (shift x (n + 1) b) s

alphaEq      :: PTerm      -> PTerm      -> Bool

alphaEq (Free a1) (Free a2) = a1 == a2
alphaEq (Binded a1) (Binded a2) = a1 == a2
alphaEq (Application a1 b1) (Application a2 b2) = alphaEq a1 a2 && alphaEq b1 b2
alphaEq (Lambda _ a1 b1) (Lambda _ a2 b2) = alphaEq a1 a2 && alphaEq b1 b2
alphaEq (Pi _ a1 b1 _) (Pi _ a2 b2 _) = alphaEq a1 a2 && alphaEq b1 b2
alphaEq _ _ = False

betaNormal :: PTerm -> PTerm
betaNormal (Free a) = Free a
betaNormal (Binded a) = Binded a
betaNormal (Application a b) = let {
  aa = betaNormal a;
  bb = betaNormal b;
} in case aa of {
  Lambda _ _ cc -> betaNormal $ shift (-1) 0 $ replaceB 0 (shift 1 0 bb) cc;
  _ -> Application aa bb;
}
betaNormal (Lambda x a b) = Lambda x (betaNormal a) (betaNormal b)
betaNormal (Pi x a b s) = Pi x (betaNormal a) (betaNormal b) s

alphaBetaEq :: PTerm -> PTerm -> Bool
alphaBetaEq a b = alphaEq (betaNormal a) (betaNormal b)

internalAbstract :: (MonadError String m) => [Maybe (String, PTerm)] -> PTerm -> PTerm -> [Maybe (String, PTerm)] -> [PTerm] -> m ([Maybe (String, PTerm)], String, [PTerm])
internalAbstract c1 x tp1 c2 tm2 = do {
  if null c1
    then throwError "internal error: null c1"
    else return ();
  case x of {
    Free n -> if length c1 /= n + 1
      then throwError "internal error: length c1 /= n + 1";
      else return ();
    _ -> throwError "internal error: x /= Free _";
  };
  (x2, tp2) <- runMaybe $ last c1;
  if tp2 /= tp1
    then throwError "internal error: tp2 /= tp1"
    else return ();
  if length c1 < length c2
    then throwError "internal error: length c1 < length c2"
    else return ();
  result <- merge c1 c2;
  return (init result, x2, map (replaceF (length c1 - 1) (Binded 0)) tm2);
}

start :: (MonadError String m) => Int -> String -> Statement -> m Statement
start n i (Statement ss as rs c tm tp _) = if n < length c
  then throwError "internal error: start"
  else do {
    s <- pTermToSort tp;
    return $ Statement ss as rs (c ++ replicate (n - length c) Nothing ++ [Just (i, tm)]) (Free n) tm (Just s);
  }

arrow :: (MonadError String m) => Statement -> Statement -> m Statement
arrow (Statement ss as rs c1 x tp1 ms1) (Statement _ _ _ c2 tm2 tps2 _) = do {
  (c, x2, [tm2b]) <- internalAbstract c1 x tp1 c2 [tm2];
  s1 <- runMaybe ms1;
  s2 <- pTermToSort tps2;
  case lookup (s1, s2) rs of {
    Nothing -> throwError $ "arrow: (" ++ show s1 ++ ", " ++ show s2 ++ "): no such rule";
    Just s3 -> return $ Statement ss as rs c (Pi x2 tp1 tm2b s2) (Free s3) (lookup s3 as);
  };
}

application :: (MonadError String m) => Statement -> Statement -> m Statement
application (Statement ss as rs c1 tm1 piType s1) (Statement _ _ _ c2 tm2 tp2 s2) = do {
  c <- merge c1 c2;
  case betaNormal piType of {
    Pi _ shouldBeTp2 tpRes sRes -> do {
      if alphaBetaEq shouldBeTp2 tp2
        then return ()
        else throwError "internal error: application: type mismatch";
      return $ Statement ss as rs c (Application tm1 tm2) (replaceB 0 tm2 tpRes) (Just sRes);
    };
    _ -> throwError "internal error: application: not a pi";
  };
}

abstraction :: (MonadError String m) => Statement -> Statement -> m Statement
abstraction (Statement ss axioms rs c1 x a mas) (Statement _ _ _ c2 b bt mbs) = do {
  (c, x2, [bq, btq]) <- internalAbstract c1 x a c2 [b, bt];
  as <- runMaybe mas;
  bs <- runMaybe mbs;
  case lookup (as, bs) rs of {
    Nothing -> throwError $ "abstraction: (" ++ show as ++ ", " ++ show bs ++ "): no such rule";
    Just s3 -> return $ Statement ss axioms rs c (Lambda x2 a bq) (Pi x2 a btq bs) (Just s3);
  };
}

typed :: (MonadError String m) => Statement -> Statement -> m ()
typed (Statement _ _ _ c1 _ a _) (Statement _ _ _ c2 b _ _) = do {
  merge c1 c2;
  if alphaBetaEq a b
    then return ()
    else throwError "internal error: typed";
}
