// Qt 5. Программа для выкидывания, написанная за один день. Не получается заюзать libsh arg, т. к., видимо, мой qt не может работать с c++14. Нет TODO

#define _POSIX_C_SOURCE 1

#include <string.h>

#include <unistd.h>
#include <fcntl.h>

#include <libsh.h>

#include <QApplication>
#include <QStatusBar>
#include <QMutex>
#include <QToolBar>
#include <QMessageBox>

#include "pa-gui.hpp"

QMutex m;
bool run_thread = false;
main_window *w;

QString initial_program = "";
QString initial_source = "/tmp/untitled";

void my_thread::run (void)
{
    int line = 0;
    int column = 0;
    QString status;

    emit done (0, 0, "Checking...");

    for (;;)
      {
        SH_CTRY
          {
            FILE *fout = sh_x_fopen (w->source_line_edit->text ().toLocal8Bit ().constData (), "w");

            SH_FTRY
              {
                sh_x_fprintf (fout, "%s", w->text_edit->toPlainText ().toLocal8Bit ().constData ());
              }
            SH_FINALLY
              {
                sh_x_fclose (fout);
              }
            SH_FEND;

            int p[2];
            sh_x_pipe (p);

            pid_t pid = sh_safe_fork ();

            if (pid == 0)
              {
                close (0);
                sh_x_open (w->source_line_edit->text ().toLocal8Bit ().constData (), O_RDONLY);
                sh_x_dup2 (p[1], 2);
                sh_x_close (p[0]);
                sh_x_close (p[1]);
                sh_x_execlp (w->program_line_edit->text ().toLocal8Bit ().constData (), w->program_line_edit->text ().toLocal8Bit ().constData (), (char *) NULL);
              }

            sh_x_close (p[1]);

            if (sh_code (sh_waitpid_status (pid, 0)) == EXIT_SUCCESS)
              {
                line = 0;
                status = "Success";
              }
            else
              {
                char s[1000];
                s[sh_x_read (p[0], s, sizeof (s) - 1)] = '\0';
                status = s;

                if (strchr (s, ':') == 0 || sscanf (strchr (s, ':'), ":%d:%d", &line, &column) != 2)
                  {
                    line = 1;
                    column = 1;
                  }
              }

            sh_x_close (p[0]);
          }
        SH_CATCH
          {
            line = 1;
            column = 1;
            status = "Libsh error, see stderr for details";
          }
        SH_CEND;

        m.lock ();
        if (!run_thread)
          {
            m.unlock ();
            break;
          }
        run_thread = false;
        m.unlock ();
      }

    emit done (line, column, status);
}

void main_window::text_changed (void)
{
    if (thr->isRunning ())
      {
        m.lock ();
        run_thread = true;
        m.unlock ();
      }
    else
      {
        thr->start ();
      }
}

void main_window::draw (int line, int column, const QString &status)
{
    QTextCursor cursor (text_edit->document ());
    auto format = cursor.charFormat ();

    disconnect (text_edit, SIGNAL (textChanged ()), 0, 0);

    cursor.movePosition (QTextCursor::Start, QTextCursor::MoveAnchor);
    cursor.movePosition (QTextCursor::End, QTextCursor::KeepAnchor);
    format.setBackground (Qt::white);
    cursor.setCharFormat (format);

    if (line != 0)
      {
        cursor.movePosition (QTextCursor::Start, QTextCursor::MoveAnchor);
        if (cursor.movePosition (QTextCursor::NextBlock, QTextCursor::MoveAnchor, line - 1) && cursor.movePosition (QTextCursor::Right, QTextCursor::MoveAnchor, column - 1))
          {
            cursor.movePosition (QTextCursor::End, QTextCursor::KeepAnchor);

            format.setBackground (Qt::red);
            cursor.setCharFormat (format);
          }
      }

    connect (text_edit, SIGNAL (textChanged ()), this, SLOT (text_changed ()));

    statusBar ()->showMessage (status);
}

main_window::main_window (QWidget *parent) : QMainWindow (parent)
{
  {
    auto toolbar = new QToolBar;

      {
        program_line_edit = new QLineEdit (initial_program);
        toolbar->addWidget (program_line_edit);
      }

      {
        source_line_edit = new QLineEdit (initial_source);
        toolbar->addWidget (source_line_edit);
      }

    addToolBar (toolbar);
  }

    text_edit = new QPlainTextEdit;

    {
      auto font = text_edit->document ()->defaultFont ();
      font.setFamily ("Courier");
      text_edit->document ()->setDefaultFont (font);
    }

    setCentralWidget (text_edit);

    statusBar ();

    thr = new my_thread;

    connect (thr, SIGNAL (done (int, int, const QString &)), this, SLOT (draw (int, int, const QString &)));

  {
    int in = open (initial_source.toLocal8Bit ().constData (), O_RDONLY);

    if (in != -1)
      {
        constexpr int n = 10000;

        char *s = new char[n];

        int len = read (in, s, n - 1);

        if (len == -1)
          {
            sh_throw ("read");
          }

        s[len] = '\0';

        if (read (in, s, 1) != 0)
          {
            sh_throwx ("file is too big");
          }

        ::close (in);

        text_edit->setPlainText (s);

        delete [] s;
      }
  }

  connect (text_edit, SIGNAL (textChanged ()), this, SLOT (text_changed ()));
}

main_window::~main_window (void)
{
    m.lock ();
    run_thread = false;
    m.unlock ();

    thr->wait ();

    if (thr->isFinished ())
      {
        delete thr;
      }
    else
      {
        // Something really bad happened
      }
}

int main (int argc, char *argv[])
{
  sh_init (argv[0]);
  QApplication a (argc, argv);

  ++argv;

  if (*argv != NULL && strcmp (*argv, "-p") == 0)
    {
      ++argv;
      initial_program = *argv;
      ++argv;
    }

  if (*argv != NULL)
    {
      initial_source = *argv;
    }

  w = new main_window;
  w->show ();
  int result = a.exec ();
  delete w;
  return result;
}
